package com.hkbu.asynctask;

import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;

public class AsyncTaskExampleActivity extends Activity {
	private ImageView iv;
	private Button loadImgBtn;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        iv = (ImageView)findViewById(R.id.myImage);
        loadImgBtn = (Button)findViewById(R.id.loadImage);
        loadImgBtn.setOnClickListener(myButtonListener);
    }
    
    private OnClickListener myButtonListener = new OnClickListener(){
		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub
			new DownloadImageTask().execute();
		}
    };
    
    private class DownloadImageTask extends AsyncTask<Integer, Void, Bitmap> {
    	@Override
        protected Bitmap doInBackground(Integer... params) {
    		try{
    			String imgLink = "http://www.comp.hkbu.edu.hk/~sigis/android/public/picture1.jpg";
        		URL url = new URL(imgLink);
        		URLConnection conn = url.openConnection();
     	        conn.connect();
     	        InputStream is = conn.getInputStream();
     	        BitmapFactory.Options options = new BitmapFactory.Options();
     	        options.inSampleSize = 4;
     	        Bitmap bm = BitmapFactory.decodeStream(is, null, options);
     	        is.close();
     	        return bm;
     	    } catch (Exception e) {
     	    	Log.v("Exception:", e.toString());
     	        return null;
     	    }
        }
    	
        @Override 
        protected void onPostExecute(Bitmap result) {
        	super.onPostExecute(result);
        	if(result!=null){
        		iv.setImageBitmap(result);
        	}
        }
        
        @Override 
        protected void onPreExecute() {  
            // TODO Auto-generated method stub
        }
    }
}