package com.hkbu.improveduxp;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;

public class ImprovedUXPexampleActivity extends Activity {
	
	private NotificationManager manager;
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        manager = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.my_menu, menu);
        return true;
    }
    
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
        case R.id.menu_1:
            //Toast.makeText(getApplicationContext(), "Item 1", Toast.LENGTH_SHORT).show();
        	showDialog();
            return true;
        case R.id.menu_2:
        	//Toast.makeText(getApplicationContext(), "Item 2", Toast.LENGTH_SHORT).show();
        	createNotification();
            return true;
        case R.id.menu_3:
        	//Toast.makeText(getApplicationContext(), "Item 3", Toast.LENGTH_SHORT).show();
        	removeNotification();
            return true;
        case R.id.menu_4:
        	Toast.makeText(getApplicationContext(), "Item 4", Toast.LENGTH_SHORT).show();
            return true;
        case R.id.menu_5:
        	Toast.makeText(getApplicationContext(), "Item 5", Toast.LENGTH_SHORT).show();
            return true;
        case R.id.menu_6:
        	Toast.makeText(getApplicationContext(), "Item 6", Toast.LENGTH_SHORT).show();
            return true;
        case R.id.menu_7:
        	Toast.makeText(getApplicationContext(), "Item 7", Toast.LENGTH_SHORT).show();
            return true;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
    
    private void showDialog(){
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	builder.setMessage("Please confirm your choice:")
    		   .setTitle("AlertDialog example")
    	       .setCancelable(false)
    	       .setIcon(R.drawable.ic_launcher);
    	
    	builder.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
    		public void onClick(DialogInterface dialog, int id) {
	        	   Toast.makeText(getApplicationContext(), "Selected: Yes", Toast.LENGTH_SHORT).show();
	           }
	    });
    	
    	builder.setNeutralButton("No", new DialogInterface.OnClickListener() {
           public void onClick(DialogInterface dialog, int id) {
        	   Toast.makeText(getApplicationContext(), "Selected: No", Toast.LENGTH_SHORT).show();
           }
    	});
    	
    	builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
           public void onClick(DialogInterface dialog, int id) {
        	   dialog.cancel();
        	   Toast.makeText(getApplicationContext(), "Dialog dismissed", Toast.LENGTH_SHORT).show();
           }
    	});
    	AlertDialog alert = builder.create();
    	alert.show();
    }
    
    private void createNotification(){
    	int icon = R.drawable.ic_menu_agenda;        
    	CharSequence tickerText = "Creating notification";         
    	long when = System.currentTimeMillis();
    	Context context = getApplicationContext();
    	CharSequence contentTitle = "Notification example";
    	CharSequence contentText = "Click here to go back the activity";

    	Intent notificationIntent = new Intent(this, ImprovedUXPexampleActivity.class);
    	PendingIntent contentIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);

    	Notification notification = new Notification(icon, tickerText, when);
    	notification.setLatestEventInfo(context, contentTitle, contentText, contentIntent);
    	notification.flags |= Notification.FLAG_ONGOING_EVENT;
    	manager.notify(0, notification);
    }
    
    private void removeNotification(){
    	manager.cancel(0);
    }
}