package com.hkbu.locationexample;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapView;
import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.widget.TextView;

public class LocationExampleActivity extends MapActivity {
   
	private LocationManager locationManager;
	private LocationListener locationListener;
	double latitude = 0;
	double longitude = 0;
	private TextView latTextView;
	private TextView longTextView;
	private MapView mapView;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        latTextView = (TextView)findViewById(R.id.latitude);
        longTextView = (TextView)findViewById(R.id.longtitude);
        mapView = (MapView)findViewById(R.id.mapView);
        mapView.setBuiltInZoomControls(true);
        mapView.getController().setZoom(10);
        
        locationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
        locationListener = new LocationListener() {
        	@Override
            public void onLocationChanged(Location location) {
        		latitude = location.getLatitude();
        		longitude = location.getLongitude();
        		latTextView.setText("Latitude: " + latitude);
        		longTextView.setText("Longitude: "+ longitude);
        		mapView.getController().animateTo(new GeoPoint((int)(latitude*1E6), (int)(longitude*1E6)));
            }
        	@Override
            public void onStatusChanged(String provider, int status, Bundle extras) {}
        	@Override
            public void onProviderEnabled(String provider) {}
        	@Override
            public void onProviderDisabled(String provider) {}
          };
        locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, locationListener);
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, locationListener);
    }
    
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	@Override
    protected void onStop(){
		super.onStop();
    	locationManager.removeUpdates(locationListener);
	}
}